
import signal
import socket
import multiprocessing

class TCP_TestServer(object):
    def __init__(self, s_addr='127.0.0.1', s_port=5530):
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.addr = s_addr if isinstance(s_addr, str) else '127.0.0.1'
        self.port = s_port if isinstance(s_port, int) else 5530
        if self.sock:
            self.sock.bind((self.addr, self.port))
            self.sock.listen(1)

    def __del__(self):
        del self.sock

    def start(self):
        if self.sock:
            try:
                while True:
                    (conn, addr) = self.sock.accept()
                    with conn:
                        while True:
                            data = conn.recv(1024)
                            if not data:
                                break
                            #print('addr: {}, data: {}'.format(addr, data))
            except KeyboardInterrupt:
                pass

if __name__ == "__main__":
    s1 = TCP_TestServer('localhost', 34000)
    s2 = TCP_TestServer('localhost', 34001)
    p1 = multiprocessing.Process(target=s1.start, args=())
    p2 = multiprocessing.Process(target=s2.start, args=())
    p1.start()
    p2.start()
    p1.join()
    p2.join()

